package com.hfkj.dao;

import com.hfkj.entity.BsMealTableOrderChildProduct;
import com.hfkj.entity.BsMealTableOrderChildProductExample.Criteria;
import com.hfkj.entity.BsMealTableOrderChildProductExample.Criterion;
import com.hfkj.entity.BsMealTableOrderChildProductExample;
import java.util.List;
import java.util.Map;
import org.apache.ibatis.jdbc.SQL;

public class BsMealTableOrderChildProductSqlProvider {

    public String countByExample(BsMealTableOrderChildProductExample example) {
        SQL sql = new SQL();
        sql.SELECT("count(*)").FROM("bs_meal_table_order_child_product");
        applyWhere(sql, example, false);
        return sql.toString();
    }

    public String deleteByExample(BsMealTableOrderChildProductExample example) {
        SQL sql = new SQL();
        sql.DELETE_FROM("bs_meal_table_order_child_product");
        applyWhere(sql, example, false);
        return sql.toString();
    }

    public String insertSelective(BsMealTableOrderChildProduct record) {
        SQL sql = new SQL();
        sql.INSERT_INTO("bs_meal_table_order_child_product");
        
        if (record.getStoreId() != null) {
            sql.VALUES("store_id", "#{storeId,jdbcType=BIGINT}");
        }
        
        if (record.getStoreName() != null) {
            sql.VALUES("store_name", "#{storeName,jdbcType=VARCHAR}");
        }
        
        if (record.getChildOrderId() != null) {
            sql.VALUES("child_order_id", "#{childOrderId,jdbcType=BIGINT}");
        }
        
        if (record.getChildOrderNo() != null) {
            sql.VALUES("child_order_no", "#{childOrderNo,jdbcType=VARCHAR}");
        }
        
        if (record.getProductCategoryId() != null) {
            sql.VALUES("product_category_id", "#{productCategoryId,jdbcType=BIGINT}");
        }
        
        if (record.getProductCategoryName() != null) {
            sql.VALUES("product_category_name", "#{productCategoryName,jdbcType=VARCHAR}");
        }
        
        if (record.getProductId() != null) {
            sql.VALUES("product_id", "#{productId,jdbcType=BIGINT}");
        }
        
        if (record.getProductImg() != null) {
            sql.VALUES("product_img", "#{productImg,jdbcType=VARCHAR}");
        }
        
        if (record.getProductName() != null) {
            sql.VALUES("product_name", "#{productName,jdbcType=VARCHAR}");
        }
        
        if (record.getProductSpec() != null) {
            sql.VALUES("product_spec", "#{productSpec,jdbcType=VARCHAR}");
        }
        
        if (record.getProductPrice() != null) {
            sql.VALUES("product_price", "#{productPrice,jdbcType=DECIMAL}");
        }
        
        if (record.getProductNum() != null) {
            sql.VALUES("product_num", "#{productNum,jdbcType=INTEGER}");
        }
        
        if (record.getProductTotalPrice() != null) {
            sql.VALUES("product_total_price", "#{productTotalPrice,jdbcType=DECIMAL}");
        }
        
        if (record.getStatus() != null) {
            sql.VALUES("`status`", "#{status,jdbcType=INTEGER}");
        }
        
        if (record.getCreateTime() != null) {
            sql.VALUES("create_time", "#{createTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getUpdateTime() != null) {
            sql.VALUES("update_time", "#{updateTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getExt1() != null) {
            sql.VALUES("ext_1", "#{ext1,jdbcType=VARCHAR}");
        }
        
        if (record.getExt2() != null) {
            sql.VALUES("ext_2", "#{ext2,jdbcType=VARCHAR}");
        }
        
        if (record.getExt3() != null) {
            sql.VALUES("ext_3", "#{ext3,jdbcType=VARCHAR}");
        }
        
        return sql.toString();
    }

    public String selectByExample(BsMealTableOrderChildProductExample example) {
        SQL sql = new SQL();
        if (example != null && example.isDistinct()) {
            sql.SELECT_DISTINCT("id");
        } else {
            sql.SELECT("id");
        }
        sql.SELECT("store_id");
        sql.SELECT("store_name");
        sql.SELECT("child_order_id");
        sql.SELECT("child_order_no");
        sql.SELECT("product_category_id");
        sql.SELECT("product_category_name");
        sql.SELECT("product_id");
        sql.SELECT("product_img");
        sql.SELECT("product_name");
        sql.SELECT("product_spec");
        sql.SELECT("product_price");
        sql.SELECT("product_num");
        sql.SELECT("product_total_price");
        sql.SELECT("`status`");
        sql.SELECT("create_time");
        sql.SELECT("update_time");
        sql.SELECT("ext_1");
        sql.SELECT("ext_2");
        sql.SELECT("ext_3");
        sql.FROM("bs_meal_table_order_child_product");
        applyWhere(sql, example, false);
        
        if (example != null && example.getOrderByClause() != null) {
            sql.ORDER_BY(example.getOrderByClause());
        }
        
        return sql.toString();
    }

    public String updateByExampleSelective(Map<String, Object> parameter) {
        BsMealTableOrderChildProduct record = (BsMealTableOrderChildProduct) parameter.get("record");
        BsMealTableOrderChildProductExample example = (BsMealTableOrderChildProductExample) parameter.get("example");
        
        SQL sql = new SQL();
        sql.UPDATE("bs_meal_table_order_child_product");
        
        if (record.getId() != null) {
            sql.SET("id = #{record.id,jdbcType=BIGINT}");
        }
        
        if (record.getStoreId() != null) {
            sql.SET("store_id = #{record.storeId,jdbcType=BIGINT}");
        }
        
        if (record.getStoreName() != null) {
            sql.SET("store_name = #{record.storeName,jdbcType=VARCHAR}");
        }
        
        if (record.getChildOrderId() != null) {
            sql.SET("child_order_id = #{record.childOrderId,jdbcType=BIGINT}");
        }
        
        if (record.getChildOrderNo() != null) {
            sql.SET("child_order_no = #{record.childOrderNo,jdbcType=VARCHAR}");
        }
        
        if (record.getProductCategoryId() != null) {
            sql.SET("product_category_id = #{record.productCategoryId,jdbcType=BIGINT}");
        }
        
        if (record.getProductCategoryName() != null) {
            sql.SET("product_category_name = #{record.productCategoryName,jdbcType=VARCHAR}");
        }
        
        if (record.getProductId() != null) {
            sql.SET("product_id = #{record.productId,jdbcType=BIGINT}");
        }
        
        if (record.getProductImg() != null) {
            sql.SET("product_img = #{record.productImg,jdbcType=VARCHAR}");
        }
        
        if (record.getProductName() != null) {
            sql.SET("product_name = #{record.productName,jdbcType=VARCHAR}");
        }
        
        if (record.getProductSpec() != null) {
            sql.SET("product_spec = #{record.productSpec,jdbcType=VARCHAR}");
        }
        
        if (record.getProductPrice() != null) {
            sql.SET("product_price = #{record.productPrice,jdbcType=DECIMAL}");
        }
        
        if (record.getProductNum() != null) {
            sql.SET("product_num = #{record.productNum,jdbcType=INTEGER}");
        }
        
        if (record.getProductTotalPrice() != null) {
            sql.SET("product_total_price = #{record.productTotalPrice,jdbcType=DECIMAL}");
        }
        
        if (record.getStatus() != null) {
            sql.SET("`status` = #{record.status,jdbcType=INTEGER}");
        }
        
        if (record.getCreateTime() != null) {
            sql.SET("create_time = #{record.createTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getUpdateTime() != null) {
            sql.SET("update_time = #{record.updateTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getExt1() != null) {
            sql.SET("ext_1 = #{record.ext1,jdbcType=VARCHAR}");
        }
        
        if (record.getExt2() != null) {
            sql.SET("ext_2 = #{record.ext2,jdbcType=VARCHAR}");
        }
        
        if (record.getExt3() != null) {
            sql.SET("ext_3 = #{record.ext3,jdbcType=VARCHAR}");
        }
        
        applyWhere(sql, example, true);
        return sql.toString();
    }

    public String updateByExample(Map<String, Object> parameter) {
        SQL sql = new SQL();
        sql.UPDATE("bs_meal_table_order_child_product");
        
        sql.SET("id = #{record.id,jdbcType=BIGINT}");
        sql.SET("store_id = #{record.storeId,jdbcType=BIGINT}");
        sql.SET("store_name = #{record.storeName,jdbcType=VARCHAR}");
        sql.SET("child_order_id = #{record.childOrderId,jdbcType=BIGINT}");
        sql.SET("child_order_no = #{record.childOrderNo,jdbcType=VARCHAR}");
        sql.SET("product_category_id = #{record.productCategoryId,jdbcType=BIGINT}");
        sql.SET("product_category_name = #{record.productCategoryName,jdbcType=VARCHAR}");
        sql.SET("product_id = #{record.productId,jdbcType=BIGINT}");
        sql.SET("product_img = #{record.productImg,jdbcType=VARCHAR}");
        sql.SET("product_name = #{record.productName,jdbcType=VARCHAR}");
        sql.SET("product_spec = #{record.productSpec,jdbcType=VARCHAR}");
        sql.SET("product_price = #{record.productPrice,jdbcType=DECIMAL}");
        sql.SET("product_num = #{record.productNum,jdbcType=INTEGER}");
        sql.SET("product_total_price = #{record.productTotalPrice,jdbcType=DECIMAL}");
        sql.SET("`status` = #{record.status,jdbcType=INTEGER}");
        sql.SET("create_time = #{record.createTime,jdbcType=TIMESTAMP}");
        sql.SET("update_time = #{record.updateTime,jdbcType=TIMESTAMP}");
        sql.SET("ext_1 = #{record.ext1,jdbcType=VARCHAR}");
        sql.SET("ext_2 = #{record.ext2,jdbcType=VARCHAR}");
        sql.SET("ext_3 = #{record.ext3,jdbcType=VARCHAR}");
        
        BsMealTableOrderChildProductExample example = (BsMealTableOrderChildProductExample) parameter.get("example");
        applyWhere(sql, example, true);
        return sql.toString();
    }

    public String updateByPrimaryKeySelective(BsMealTableOrderChildProduct record) {
        SQL sql = new SQL();
        sql.UPDATE("bs_meal_table_order_child_product");
        
        if (record.getStoreId() != null) {
            sql.SET("store_id = #{storeId,jdbcType=BIGINT}");
        }
        
        if (record.getStoreName() != null) {
            sql.SET("store_name = #{storeName,jdbcType=VARCHAR}");
        }
        
        if (record.getChildOrderId() != null) {
            sql.SET("child_order_id = #{childOrderId,jdbcType=BIGINT}");
        }
        
        if (record.getChildOrderNo() != null) {
            sql.SET("child_order_no = #{childOrderNo,jdbcType=VARCHAR}");
        }
        
        if (record.getProductCategoryId() != null) {
            sql.SET("product_category_id = #{productCategoryId,jdbcType=BIGINT}");
        }
        
        if (record.getProductCategoryName() != null) {
            sql.SET("product_category_name = #{productCategoryName,jdbcType=VARCHAR}");
        }
        
        if (record.getProductId() != null) {
            sql.SET("product_id = #{productId,jdbcType=BIGINT}");
        }
        
        if (record.getProductImg() != null) {
            sql.SET("product_img = #{productImg,jdbcType=VARCHAR}");
        }
        
        if (record.getProductName() != null) {
            sql.SET("product_name = #{productName,jdbcType=VARCHAR}");
        }
        
        if (record.getProductSpec() != null) {
            sql.SET("product_spec = #{productSpec,jdbcType=VARCHAR}");
        }
        
        if (record.getProductPrice() != null) {
            sql.SET("product_price = #{productPrice,jdbcType=DECIMAL}");
        }
        
        if (record.getProductNum() != null) {
            sql.SET("product_num = #{productNum,jdbcType=INTEGER}");
        }
        
        if (record.getProductTotalPrice() != null) {
            sql.SET("product_total_price = #{productTotalPrice,jdbcType=DECIMAL}");
        }
        
        if (record.getStatus() != null) {
            sql.SET("`status` = #{status,jdbcType=INTEGER}");
        }
        
        if (record.getCreateTime() != null) {
            sql.SET("create_time = #{createTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getUpdateTime() != null) {
            sql.SET("update_time = #{updateTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getExt1() != null) {
            sql.SET("ext_1 = #{ext1,jdbcType=VARCHAR}");
        }
        
        if (record.getExt2() != null) {
            sql.SET("ext_2 = #{ext2,jdbcType=VARCHAR}");
        }
        
        if (record.getExt3() != null) {
            sql.SET("ext_3 = #{ext3,jdbcType=VARCHAR}");
        }
        
        sql.WHERE("id = #{id,jdbcType=BIGINT}");
        
        return sql.toString();
    }

    protected void applyWhere(SQL sql, BsMealTableOrderChildProductExample example, boolean includeExamplePhrase) {
        if (example == null) {
            return;
        }
        
        String parmPhrase1;
        String parmPhrase1_th;
        String parmPhrase2;
        String parmPhrase2_th;
        String parmPhrase3;
        String parmPhrase3_th;
        if (includeExamplePhrase) {
            parmPhrase1 = "%s #{example.oredCriteria[%d].allCriteria[%d].value}";
            parmPhrase1_th = "%s #{example.oredCriteria[%d].allCriteria[%d].value,typeHandler=%s}";
            parmPhrase2 = "%s #{example.oredCriteria[%d].allCriteria[%d].value} and #{example.oredCriteria[%d].criteria[%d].secondValue}";
            parmPhrase2_th = "%s #{example.oredCriteria[%d].allCriteria[%d].value,typeHandler=%s} and #{example.oredCriteria[%d].criteria[%d].secondValue,typeHandler=%s}";
            parmPhrase3 = "#{example.oredCriteria[%d].allCriteria[%d].value[%d]}";
            parmPhrase3_th = "#{example.oredCriteria[%d].allCriteria[%d].value[%d],typeHandler=%s}";
        } else {
            parmPhrase1 = "%s #{oredCriteria[%d].allCriteria[%d].value}";
            parmPhrase1_th = "%s #{oredCriteria[%d].allCriteria[%d].value,typeHandler=%s}";
            parmPhrase2 = "%s #{oredCriteria[%d].allCriteria[%d].value} and #{oredCriteria[%d].criteria[%d].secondValue}";
            parmPhrase2_th = "%s #{oredCriteria[%d].allCriteria[%d].value,typeHandler=%s} and #{oredCriteria[%d].criteria[%d].secondValue,typeHandler=%s}";
            parmPhrase3 = "#{oredCriteria[%d].allCriteria[%d].value[%d]}";
            parmPhrase3_th = "#{oredCriteria[%d].allCriteria[%d].value[%d],typeHandler=%s}";
        }
        
        StringBuilder sb = new StringBuilder();
        List<Criteria> oredCriteria = example.getOredCriteria();
        boolean firstCriteria = true;
        for (int i = 0; i < oredCriteria.size(); i++) {
            Criteria criteria = oredCriteria.get(i);
            if (criteria.isValid()) {
                if (firstCriteria) {
                    firstCriteria = false;
                } else {
                    sb.append(" or ");
                }
                
                sb.append('(');
                List<Criterion> criterions = criteria.getAllCriteria();
                boolean firstCriterion = true;
                for (int j = 0; j < criterions.size(); j++) {
                    Criterion criterion = criterions.get(j);
                    if (firstCriterion) {
                        firstCriterion = false;
                    } else {
                        sb.append(" and ");
                    }
                    
                    if (criterion.isNoValue()) {
                        sb.append(criterion.getCondition());
                    } else if (criterion.isSingleValue()) {
                        if (criterion.getTypeHandler() == null) {
                            sb.append(String.format(parmPhrase1, criterion.getCondition(), i, j));
                        } else {
                            sb.append(String.format(parmPhrase1_th, criterion.getCondition(), i, j,criterion.getTypeHandler()));
                        }
                    } else if (criterion.isBetweenValue()) {
                        if (criterion.getTypeHandler() == null) {
                            sb.append(String.format(parmPhrase2, criterion.getCondition(), i, j, i, j));
                        } else {
                            sb.append(String.format(parmPhrase2_th, criterion.getCondition(), i, j, criterion.getTypeHandler(), i, j, criterion.getTypeHandler()));
                        }
                    } else if (criterion.isListValue()) {
                        sb.append(criterion.getCondition());
                        sb.append(" (");
                        List<?> listItems = (List<?>) criterion.getValue();
                        boolean comma = false;
                        for (int k = 0; k < listItems.size(); k++) {
                            if (comma) {
                                sb.append(", ");
                            } else {
                                comma = true;
                            }
                            if (criterion.getTypeHandler() == null) {
                                sb.append(String.format(parmPhrase3, i, j, k));
                            } else {
                                sb.append(String.format(parmPhrase3_th, i, j, k, criterion.getTypeHandler()));
                            }
                        }
                        sb.append(')');
                    }
                }
                sb.append(')');
            }
        }
        
        if (sb.length() > 0) {
            sql.WHERE(sb.toString());
        }
    }
}